import shutil
from abc import ABC, abstractmethod
from pathlib import Path
import os


class BaseSaver(ABC):
    _sav_path = os.getenv('SAVER_DIR', 'sav')

    @abstractmethod
    def save(self) -> Path:
        pass

    @abstractmethod
    def _check_if_computer_have_dependency(self) -> bool:
        pass

    @classmethod
    def _get_dir_save_path(cls) -> Path:
        return Path.joinpath(Path.cwd(), cls._sav_path)

    @classmethod
    def _initialize_sav_dir(cls) -> None:
        if os.path.exists(cls._get_dir_save_path()):
            shutil.rmtree(cls._get_dir_save_path())
        os.makedirs(cls._get_dir_save_path())